------------------------------------------
--              Helm Control            --
--               by Khrill              --
--                                      --
--                v 2.4.0               --
------------------------------------------

KHC = {}
KHC.name  = "KhrillHelmControl"
KHC.version = "2.4.0"
KHC.defaults = {
	EnableAuto = true,
	DefaultHelm = false,
	CombatMode = true,
	SteatheMode = false,
	WeaponsMode = false,
	HorseMode = true,
	CraftMode = true,
	EmoteMode = false,
	CityMode = false,
	CyrodiilMode = false,
	LogInfo = true,
}
KHC.settings = KHC.defaults
KHC.langString = nil
KHC.weapons = false
KHC.weaponsbeforeaction = false
KHC.activeWeaponPair = nil
KHC.helmbeforecraft = nil
KHC.helmbeforemount = nil
KHC.notDisarm = false
KHC.manual = false
KHC.inCity = false
KHC.activate = false
KHC.isDebug = false

KHC.Addins = {
	FOV = false,
}

local EMOTEINDEX = {
	show = 151, --doom
	hide = 95, --phew
}
local COLOR_KHRILLSELECT = "FF6A00" -- orange ^^
local COLOR_TITLE = "FF0000" -- red ^^

-- // **********
-- //  States
-- // **********
function KHC:getWeaponState()
	if KHC.weapons then
		return 1
	else
		return 0
	end
end
function KHC:getWeaponBeforeState()
	if KHC.weaponsbeforeaction then
		return 1
	else
		return 0
	end
end
function KHC:IsHelmet()
	-- true if helm shown
	return (GetSetting(SETTING_TYPE_IN_WORLD, IN_WORLD_UI_SETTING_HIDE_HELM) == "0")
end
function KHC:ShowHelmet(blState)
	-- check if Cyroddil then force helm
	if KHC.settings.CyrodiilMode and IsInCampaign() then
		if not KHC:IsHelmet() then
			SetSetting(SETTING_TYPE_IN_WORLD, IN_WORLD_UI_SETTING_HIDE_HELM, "0")
--			SetSetting(SETTING_TYPE_IN_WORLD, IN_WORLD_UI_SETTING_HIDE_HELM, "1")
--			SetSetting(SETTING_TYPE_IN_WORLD, IN_WORLD_UI_SETTING_HIDE_HELM, "0")
			--check FOV addin
			if KHC.Addins.FOV then KHCFOV:Put() end
		end
	else
		if blState and not KHC:IsHelmet() then
		KHC:msg("--ShowHelmet True")

			if IsMounted() or not KHC.settings.EmoteMode or KHC.weaponsbeforeaction or KHC.weapons then
				SetSetting(SETTING_TYPE_IN_WORLD, IN_WORLD_UI_SETTING_HIDE_HELM, "0")
--				SetSetting(SETTING_TYPE_IN_WORLD, IN_WORLD_UI_SETTING_HIDE_HELM, "1")
--				SetSetting(SETTING_TYPE_IN_WORLD, IN_WORLD_UI_SETTING_HIDE_HELM, "0")
			else
				PlayEmoteByIndex(EMOTEINDEX.show) 
				zo_callLater(function() SetSetting(SETTING_TYPE_IN_WORLD, IN_WORLD_UI_SETTING_HIDE_HELM, "0") end, 300 + KHC:getWeaponState()*1100)
			end
			--check FOV addin
			if KHC.Addins.FOV then KHCFOV:Put() end
		end
		if not blState and KHC:IsHelmet() then
		KHC:msg("--ShowHelmet False")	
			if KHC.settings.EmoteMode then
				if not IsMounted() or not KHC.settings.WeaponsMode or (KHC.manual and not KHC.weapons) or (KHC.weaponsbeforeaction and not KHC.weapons) then
					PlayEmoteByIndex(EMOTEINDEX.hide) 
					zo_callLater(function() SetSetting(SETTING_TYPE_IN_WORLD, IN_WORLD_UI_SETTING_HIDE_HELM, "1") end, 900 + KHC:getWeaponBeforeState()*1400)
				else
--					SetSetting(SETTING_TYPE_IN_WORLD, IN_WORLD_UI_SETTING_HIDE_HELM, "1")
--					SetSetting(SETTING_TYPE_IN_WORLD, IN_WORLD_UI_SETTING_HIDE_HELM, "0")
					SetSetting(SETTING_TYPE_IN_WORLD, IN_WORLD_UI_SETTING_HIDE_HELM, "1")
				end
			else
--				SetSetting(SETTING_TYPE_IN_WORLD, IN_WORLD_UI_SETTING_HIDE_HELM, "1")
--				SetSetting(SETTING_TYPE_IN_WORLD, IN_WORLD_UI_SETTING_HIDE_HELM, "0")
				SetSetting(SETTING_TYPE_IN_WORLD, IN_WORLD_UI_SETTING_HIDE_HELM, "1")
			end
			--check FOV addin
			if KHC.Addins.FOV then KHCFOV:Remove() end
		end
	end
	KHC.weaponsbeforeaction = KHC.weapons
end

function KHC:ManualHelmet()
	-- by keybind
	KHC.manual = true
	KHC:ShowHelmet(not KHC:IsHelmet())
end

-- // **********
-- //  Events
-- // **********
function KHC:OnDisarm(blState)
KHC:msg("--OnDisarm "..tostring(blState))
	if KHC.settings.CityMode and KHC.inCity and not KHC.manual then
		KHC:ShowHelmet(false)
	elseif blState then
		if KHC.settings.WeaponsMode then
--			if KHC.weapons then zo_callLater(TogglePlayerWield(), 1500) end
			KHC.weaponsbeforeaction = KHC.weapons
			KHC.weapons = false
			if not KHC.manual then KHC:ShowHelmet(KHC.settings.DefaultHelm) end
		else
			KHC:ShowHelmet(KHC.settings.DefaultHelm)
		end
	else
		if KHC.settings.WeaponsMode then
			KHC.weaponsbeforeaction = KHC.weapons
			--KHC.weapons = not blState
			if not KHC.manual then KHC:ShowHelmet(KHC.weapons or KHC.settings.DefaultHelm) end
		end
	end
	KHC.notDisarm = false
end

function KHC:OnCombatState(inCombat)
KHC:msg("--OnCombatState "..tostring(inCombat))
	KHC.manual = false
	if KHC.settings.SteatheMode and not (inCombat) then -- and not (IsUnitInCombat("player")) then
		zo_callLater(function() if not (IsUnitInCombat("player")) then TogglePlayerWield() end end, 1500)
	end
	if KHC.settings.WeaponsMode then
		if (not KHC.weapons) or inCombat then
			KHC.weapons = true
			KHC:ShowHelmet(true)
		end 
	elseif KHC.settings.CombatMode then
		KHC:ShowHelmet(KHC.settings.WeaponsMode or IsUnitInCombat("player")) --or inCombat)
	end
	KHC.notDisarm = false
end

function KHC:OnMountedState()
	KHC.manual = false
	if KHC.settings.HorseMode then
KHC:msg("--OnMountedState "..tostring(IsMounted()))
		local isM = IsMounted()
		local newState = KHC:IsHelmet()
		KHC.weaponsbeforeaction = KHC.weapons
		if isM then
--			KHC.helmbeforemount = KHC:IsHelmet()
			KHC.weapons = false
		end
		if (KHC.inCity and KHC.settings.CityMode) then
			newState = false
		else
			newState = isM or KHC.weapons or KHC.settings.DefaultHelm
		end
		if not isM then --wait for unmount anim
			zo_callLater(function() KHC:ShowHelmet(newState) end, 2200)
		else
			KHC:ShowHelmet(newState)
		end
	end
end

function KHC:OnCrafting()
KHC:msg("--OnCrafting ")
	KHC.manual = false
	if KHC.settings.CraftMode then
		KHC.helmbeforecraft = KHC:IsHelmet()
		KHC.weaponsbeforeaction = KHC.weapons
		KHC.weapons = false
		KHC:ShowHelmet(false)
	else
		KHC:OnDisarm(true)
	end
end
function KHC:OnEndCrafting()
KHC:msg("--OnEndCrafting ")
	if KHC.settings.CityMode and KHC.inCity then
		KHC:ShowHelmet(false)
		KHC.helmbeforecraft = nil
	elseif KHC.settings.CraftMode and not(KHC.helmbeforecraft == nil) then
		if not KHC.settings.WeaponsMode then
			KHC:ShowHelmet(KHC.helmbeforecraft or KHC.settings.DefaultHelm)
		else
			KHC:ShowHelmet(KHC.weapons or KHC.settings.DefaultHelm)
		end
		KHC.helmbeforecraft = nil
	end
	KHC.notDisarm = true
end

function KHC:OnChatterBegin()
KHC:msg("--OnChatterBegin ")
	local isM = IsMounted()
--	KHC.manual = false
	if KHC.settings.HorseMode and isM then
	--		KHC.helmbeforemount = KHC:IsHelmet()
		return
	else
		KHC:OnDisarm(true)
	end
end
function KHC:OnChatterEnd()
KHC:msg("--OnChatterEnd "..tostring(KHC.notDisarm))
	local isM = IsMounted()
	if KHC.settings.HorseMode and isM then
		return
	--		KHC:ShowHelmet(KHC.helmbeforemount)
	else
		if not KHC.notDisarm then
			KHC:OnDisarm(true)
		end
		KHC.notDisarm = false
	end
end

function KHC.OnZoneChange()
--EVENT_ZONE_CHANGED (integer eventCode, string zoneName, string subZoneName, bool newSubzone)
--[[
MAPTYPE_ALLIANCE = 4 
MAPTYPE_COSMIC = 5 
MAPTYPE_NONE = 0 
MAPTYPE_SUBZONE = 1 
MAPTYPE_WORLD = 3 
MAPTYPE_ZONE = 2 

MAP_CONTENT_AVA = 1 
MAP_CONTENT_DUNGEON = 2 
MAP_CONTENT_NONE = 0 
]]
	KHC:msg("--OnZoneChange:"..GetMapName())
	if KHC.settings.CyrodiilMode and IsInCampaign() then
		KHC:ShowHelmet(true)
	else
		-- cities are non dungeon or ava - subzones
		if KHC.settings.CityMode and not KHC.manual then
--		KHC:msg("GetMapType(1)="..GetMapType()..", GetMapContentType(0)="..GetMapContentType())
			if GetMapType() == MAPTYPE_SUBZONE and GetMapContentType() == MAP_CONTENT_NONE  then
			KHC:msg("|c00FF00inCity -> hide|r", false)
				KHC.inCity = true
				KHC:ShowHelmet(false)
			else
				KHC.inCity = false
				if KHC.settings.HorseMode and IsMounted() then
			KHC:msg("|c0000FFoutdoor & horse -> show|r", false)
					KHC:ShowHelmet(true)
				elseif KHC.settings.WeaponsMode and KHC.weapons then
			KHC:msg("|cFF0000outdoor & weapons -> show|r", false)
					KHC:ShowHelmet(true)
				elseif IsUnitInCombat("player") and KHC.settings.CombatMode then
			KHC:msg("|cFF0000outdoor & combat -> show|r", false)
					KHC:ShowHelmet(true)		
				elseif KHC:IsHelmet() ~= KHC.settings.DefaultHelm then
			KHC:msg("|c0000FFoutdoor -> default|r", false)
					KHC:ShowHelmet(KHC.settings.DefaultHelm)
				end
			end
		end
	end
end

local origTogglePlayerWield = TogglePlayerWield
--ZO_WeaponSwap_OnMouseEnter
TogglePlayerWield = function( ... )
KHC:msg("--TogglePlayerWield ")
	KHC.manual = false
	origTogglePlayerWield (...)
	if not(IsUnitInCombat("player")) and not(KHC.settings.CyrodiilMode and IsInCampaign()) then
		KHC.weaponsbeforeaction = KHC.weapons
		if KHC.settings.WeaponsMode then KHC.weapons = not KHC.weapons end
		if not KHC.weapons then
			if KHC.settings.CityMode and KHC.inCity then
				KHC:ShowHelmet(false)
			elseif KHC.settings.WeaponsMode then
				KHC:ShowHelmet(KHC.settings.DefaultHelm)			
			end
		else
			if KHC.settings.CityMode and KHC.inCity then
				KHC:ShowHelmet(false)
			elseif KHC.settings.WeaponsMode then
				KHC:ShowHelmet(KHC.weapons or KHC.settings.DefaultHelm)
			end
		end
	end
end

-- // **********
-- //  Init
-- // **********
function KHC:GetLanguage()
	local lang = GetCVar("language.2")
--lang="de"
	--supported languages
	if(lang == "fr") then return lang end
	if(lang == "de") then return lang end
	if(lang == "es") then return lang end

	--return english if not supported
	return "en"
end
function KHC:myBindings()
	ZO_CreateStringId("SI_BINDING_NAME_DEFAULTHELMET", KHC.langString.SI_BINDING_NAME_DEFAULTHELMET) --"Helm by default On/Off")
	ZO_CreateStringId("SI_BINDING_NAME_HELMINCOMBAT", KHC.langString.SI_BINDING_NAME_HELMINCOMBAT) --"Combat Mode On/Off")
	ZO_CreateStringId("SI_BINDING_NAME_HELMWITHWEAPONS", KHC.langString.SI_BINDING_NAME_HELMWITHWEAPONS) --"Weapons Mode On/Off")
	ZO_CreateStringId("SI_BINDING_NAME_MANUALHELMET", "|c"..COLOR_KHRILLSELECT..KHC.langString.SI_BINDING_NAME_MANUALHELMET.."|r") --"Manual Helmet")
end
function KHC:registerEvents(state)
	if state then
		EVENT_MANAGER:RegisterForEvent(KHC.name, EVENT_PLAYER_COMBAT_STATE, function(...) KHC:OnCombatState(inCombat) end)
		EVENT_MANAGER:RegisterForEvent(KHC.name, EVENT_MOUNTED_STATE_CHANGED, function(...) KHC:OnMountedState() end)
		EVENT_MANAGER:RegisterForEvent(KHC.name, EVENT_CRAFTING_STATION_INTERACT, function(...) KHC:OnCrafting() end)
		EVENT_MANAGER:RegisterForEvent(KHC.name, EVENT_END_CRAFTING_STATION_INTERACT, function(...) KHC:OnEndCrafting() end)
		EVENT_MANAGER:RegisterForEvent(KHC.name, EVENT_CHATTER_BEGIN, function(...) KHC:OnChatterBegin() end)
		EVENT_MANAGER:RegisterForEvent(KHC.name, EVENT_CHATTER_END, function(...) KHC:OnChatterEnd() end)
		EVENT_MANAGER:RegisterForEvent(KHC.name, EVENT_ACTIVE_WEAPON_PAIR_CHANGED, function(eventCode, activeWeaponPair, locked)
													if not locked and activeWeaponPair ~= KHC.activeWeaponPair then
																					KHC.activeWeaponPair = activeWeaponPair
																					KHC.weapons = true
																					KHC:OnDisarm(false)
																				end
												end)
		EVENT_MANAGER:RegisterForEvent(KHC.name, EVENT_SHOW_BOOK, function(eventCode, bookTitle, body, medium, showTitle) if medium >= 2 then KHC:OnDisarm(true) else KHC.notDisarm = true end end)
		EVENT_MANAGER:RegisterForEvent(KHC.name, EVENT_BEGIN_LOCKPICK, function(...) KHC:OnDisarm(true) end)
		EVENT_MANAGER:RegisterForEvent(KHC.name, EVENT_RECIPE_LEARNED, function(...) KHC.notDisarm = true end)
		EVENT_MANAGER:RegisterForEvent(KHC.name, EVENT_MAIL_CLOSE_MAILBOX, function(...) KHC.notDisarm = true end)
		EVENT_MANAGER:RegisterForEvent(KHC.name, EVENT_INVENTORY_ITEM_USED, function(...) KHC.notDisarm = true end)
		EVENT_MANAGER:RegisterForEvent(KHC.name, EVENT_LOOT_UPDATED, function(...) KHC.notDisarm = false end)
		EVENT_MANAGER:RegisterForEvent(KHC.name, EVENT_LOOT_RECEIVED, function(eventCode, receivedBy, itemName, quantity, itemSound, lootType, self)
--				d(itemName..":"..lootType..","..itemSound)
													if self and (lootType == LOOT_TYPE_QUEST_ITEM
													or itemSound == ITEM_SOUND_CATEGORY_MINERAL_COMPONENT
													--or itemSound == ITEM_SOUND_CATEGORY_INGREDIENT
													--or itemSound == ITEM_SOUND_CATEGORY_SCROLL
													--or itemSound == ITEM_SOUND_CATEGORY_FOOD
													or itemSound == ITEM_SOUND_CATEGORY_PLANT_COMPONENT
													or itemSound == ITEM_SOUND_CATEGORY_RUNE 
													or itemSound == ITEM_SOUND_CATEGORY_METAL_COMPONENT 
													or itemSound == ITEM_SOUND_CATEGORY_CLOTH_COMPONENT 
													or itemSound == ITEM_SOUND_CATEGORY_WOOD_COMPONENT
													or itemSound == ITEM_SOUND_CATEGORY_DRINK
													) then -- item which disarms
														KHC.notDisarm = false
													else
														KHC.notDisarm = true
													end
												end)
		EVENT_MANAGER:RegisterForEvent(KHC.name, EVENT_ZONE_CHANGED, function() KHC.OnZoneChange() end)
	else
		EVENT_MANAGER:UnregisterForEvent(KHC.name, EVENT_PLAYER_COMBAT_STATE)
		EVENT_MANAGER:UnregisterForEvent(KHC.name, EVENT_MOUNTED_STATE_CHANGED)
		EVENT_MANAGER:UnregisterForEvent(KHC.name, EVENT_CRAFTING_STATION_INTERACT)
		EVENT_MANAGER:UnregisterForEvent(KHC.name, EVENT_END_CRAFTING_STATION_INTERACT)
		EVENT_MANAGER:UnregisterForEvent(KHC.name, EVENT_CHATTER_BEGIN)
		EVENT_MANAGER:UnregisterForEvent(KHC.name, EVENT_CHATTER_END)
		EVENT_MANAGER:UnregisterForEvent(KHC.name, EVENT_ACTIVE_WEAPON_PAIR_CHANGED)
		EVENT_MANAGER:UnregisterForEvent(KHC.name, EVENT_SHOW_BOOK)
		EVENT_MANAGER:UnregisterForEvent(KHC.name, EVENT_BEGIN_LOCKPICK)
		EVENT_MANAGER:UnregisterForEvent(KHC.name, EVENT_RECIPE_LEARNED)
		EVENT_MANAGER:UnregisterForEvent(KHC.name, EVENT_MAIL_CLOSE_MAILBOX)
		EVENT_MANAGER:UnregisterForEvent(KHC.name, EVENT_INVENTORY_ITEM_USED)
		EVENT_MANAGER:UnregisterForEvent(KHC.name, EVENT_LOOT_UPDATED)
		EVENT_MANAGER:UnregisterForEvent(KHC.name, EVENT_LOOT_RECEIVED)
		EVENT_MANAGER:UnregisterForEvent(KHC.name, EVENT_ZONE_CHANGED)
	end
end
function KHC:OnInit(eventCode, addOnName)
    if ( addOnName ~= KHC.name) then return end
	
	local lang = KHC:GetLanguage()
	KHC.langString = KHC_Lang[lang]
	if lang == "fr" or lang == "de" then EMOTEINDEX.show = EMOTEINDEX.show +1 end
	KHC:myBindings()
	KHC.settings = ZO_SavedVars:New(KHC.name .. "_settings", 1, nil, KHC.defaults)
	KHC:CommandOptionPanel()
	
	KHC:registerEvents(KHC.settings.EnableAuto)

--	EVENT_MANAGER:UnregisterForEvent(KHC.name, EVENT_ADD_ON_LOADED)
end
function KHC_OnActivate()
KHC:msg("--KHC_OnActivate "..tostring(KHC.activate))
--d(GetCurrentMapIndex()..":"..tostring(GetMapParentCategories(GetCurrentMapIndex())))
--d(GetCurrentMapZoneIndex() ..":"..tostring(GetZoneNameByIndex(GetCurrentMapZoneIndex())))
	if not KHC.activate then
		if KHC.settings.LogInfo then
			local msg = "|c"..COLOR_KHRILLSELECT.."["..KHC.name.."]|r : status "
			if KHC.settings.EnableAuto then	
				if KHC.settings.DefaultHelm then
					msg = msg .. KHC.langString.MESSAGE_defaultShow
				else
					msg = msg .. KHC.langString.MESSAGE_defaultHide
				end
			else
				msg = msg .. KHC.langString.KHCSettings_keybind
			end
			CHAT_SYSTEM:AddMessage(msg)
		end
		KHC.activeWeaponPair, _ = GetActiveWeaponPairInfo()
		KHC.activate = true
	end
	
	if KHC.settings.CyrodiilMode and IsInCampaign() then
		KHC:ShowHelmet(true)
	else
		if KHC.settings.CityMode then
			-- update inCity
			KHC.inCity = (GetMapType() == MAPTYPE_SUBZONE and GetMapContentType() == MAP_CONTENT_NONE)
			KHC:msg("inCity->"..tostring(KHC.inCity))
		end
		-- test if log on mount
		if KHC.settings.HorseMode and IsMounted() then
			KHC:OnMountedState()
		elseif KHC.settings.CityMode and KHC.inCity then
			KHC:ShowHelmet(false)
		else
			KHC:ShowHelmet(KHC.settings.DefaultHelm)
		end
	end
end

EVENT_MANAGER:RegisterForEvent(KHC.name, EVENT_ADD_ON_LOADED , function(_event, _name) KHC:OnInit(_event, _name) end)
EVENT_MANAGER:RegisterForEvent(KHC.name, EVENT_PLAYER_ACTIVATED, KHC_OnActivate)


-- // **********
-- //  Settings
-- // **********
function KHC:ToggleAutoMode(value)
	KHC.settings.EnableAuto = value
	KHC:registerEvents(value)
end
function KHC:ToggleDefaultMode(value)
	KHC.settings.DefaultHelm = value
	if value then
		KHC.settings.CombatMode = false
		KHC.settings.WeaponsMode = false
	end
	KHC.activate = false
	KHC_OnActivate()
end
function KHC:ToggleCombatMode(value)
	KHC.settings.CombatMode = value
end
function KHC:ToggleWeaponsMode(value)
	KHC.settings.WeaponsMode = value
end
function KHC:ToggleCityMode(value)
	KHC.settings.CityMode = value
	if KHC.settings.CityMode then
		KHC.inCity = (GetMapType() == MAPTYPE_SUBZONE and GetMapContentType() == MAP_CONTENT_NONE)
	else
		KHC.inCity = false
	end
	if KHC.inCity then KHC:ShowHelmet(false) end
end
function KHC:ToggleCyrodiilMode(value)
	KHC.settings.CyrodiilMode = value
	if KHC.settings.CyrodiilMode and IsInCampaign() then KHC:ShowHelmet(true) end
end

function KHC:CommandOptionPanel()
	--// Settings panel LAM2
	local LAM2 = LibStub("LibAddonMenu-2.0")
	if ( not LAM2 ) then return end
	
	local ADDON_NAME="Helm Control"
	local ADDON_VERSION="v"..KHC.version
	local panelData = {
			type = "panel",
			name = ADDON_NAME,
			displayName = "|c"..COLOR_KHRILLSELECT.. ADDON_NAME .."|r (" .. KHC.langString.LOCALE .. ")",
			author = "|c"..COLOR_KHRILLSELECT.."Khrill|r",
			version = ADDON_VERSION,
			slashCommand = "/khc",
			registerForRefresh = true,
			registerForDefaults = true,
	}
	LAM2:RegisterAddonPanel(ADDON_NAME, panelData)

	local optionsTable = {
			------------MANUAL MODE--------------
		{	-- log info
			type = "checkbox",
			name = KHC.langString.KHCSettings_loginfo,
--			tooltip = KHC.langString.KHCSettings_loginfo,
			getFunc = function() return KHC.settings.LogInfo end,
			setFunc = function(value) KHC.settings.LogInfo = value end,
			width = "full",
			default = KHC.defaults.LogInfo,
		},
		{
			type = "header",
			name = "|c"..COLOR_TITLE..KHC.langString.KHCSettings_keybind.."|r",
			width = "full",
		},
		{
			type = "description",
			text = KHC.langString.KHCSettings_keybindText,
			width = "full",
		},

			------------AUTO MODE SETTINGS--------------
		{
			type = "header",
			name = "|c"..COLOR_TITLE..KHC.langString.KHCSettings_control.."|r",
			width = "full",
		},
		{	-- enable
			type = "checkbox",
			name = KHC.langString.KHCSettings_enable,
			tooltip = KHC.langString.KHCSettings_automode,
			getFunc = function() return KHC.settings.EnableAuto end,
			setFunc = function(value) KHC:ToggleAutoMode(value) end,
			width = "full",
			default = KHC.defaults.EnableAuto,
		},
		-- Default mode
		{
			type = "description",
			title = "|c"..COLOR_KHRILLSELECT..KHC.langString.KHCSettings_title0.."|r",
			text = KHC.langString.KHCSettings_description0,
			width = "full",
		},
		{
			type = "checkbox",
			name = KHC.langString.KHCSettings_enable,
			tooltip = KHC.langString.KHCSettings_defaultmode,
			getFunc = function() return KHC.settings.DefaultHelm end,
			setFunc = function(value) KHC:ToggleDefaultMode(value) end,
			width = "full",
			disabled = function() return not KHC.settings.EnableAuto end,
			default = KHC.defaults.DefaultHelm,
		},
		-- Combat mode
		{
			type = "description",
			title = "|c"..COLOR_KHRILLSELECT..KHC.langString.KHCSettings_title1.."|r",
			text = KHC.langString.KHCSettings_description1,
			width = "full",
		},
		{
			type = "checkbox",
			name = KHC.langString.KHCSettings_enable,
			tooltip = KHC.langString.KHCSettings_combatmode,
			getFunc = function() return KHC.settings.CombatMode end,
			setFunc = function(value) KHC:ToggleCombatMode(value) end,
			width = "full",
			disabled = function() return not KHC.settings.EnableAuto or KHC.settings.DefaultHelm end,
			default = KHC.defaults.CombatMode,
		},
		-- Sheathe mode
		{
			type = "description",
			title = "|c"..COLOR_KHRILLSELECT..KHC.langString.KHCSettings_title2.."|r",
			text = KHC.langString.KHCSettings_description2,
			width = "full",
		},
		{
			type = "checkbox",
			name = KHC.langString.KHCSettings_enable,
			tooltip = KHC.langString.KHCSettings_steathemode,
			getFunc = function() return KHC.settings.SteatheMode end,
			setFunc = function(value) KHC.settings.SteatheMode = value end,
			width = "full",
			disabled = function() return not KHC.settings.EnableAuto end,
			default = KHC.defaults.SteatheMode,
		},
		-- Weapons mode
		{
			type = "description",
			title = "|c"..COLOR_KHRILLSELECT..KHC.langString.KHCSettings_title3.."|r",
			text = KHC.langString.KHCSettings_description3,
			width = "full",
		},
		{
			type = "checkbox",
			name = KHC.langString.KHCSettings_enable,
			tooltip = KHC.langString.KHCSettings_weaponsmode,
			getFunc = function() return KHC.settings.WeaponsMode end,
			setFunc = function(value) KHC:ToggleWeaponsMode(value) end,
			width = "full",
			disabled = function() return not KHC.settings.EnableAuto or KHC.settings.DefaultHelm end,
			default = KHC.defaults.WeaponsMode,
		},
		-- Horse mode
		{
			type = "description",
			title = "|c"..COLOR_KHRILLSELECT..KHC.langString.KHCSettings_title4.."|r",
			text = KHC.langString.KHCSettings_description4,
			width = "full",
		},
		{
			type = "checkbox",
			name = KHC.langString.KHCSettings_enable,
			tooltip = KHC.langString.KHCSettings_horsemode,
			getFunc = function() return KHC.settings.HorseMode end,
			setFunc = function(value) KHC.settings.HorseMode = value end,
			width = "full",
			disabled = function() return not KHC.settings.EnableAuto end,
			default = KHC.defaults.HorseMode,
		},
		-- Craft mode
		{
			type = "description",
			title = "|c"..COLOR_KHRILLSELECT..KHC.langString.KHCSettings_title5.."|r",
			text = KHC.langString.KHCSettings_description5,
			width = "full",
		},
		{
			type = "checkbox",
			name = KHC.langString.KHCSettings_enable,
			tooltip = KHC.langString.KHCSettings_craftmode,
			getFunc = function() return KHC.settings.CraftMode end,
			setFunc = function(value) KHC.settings.CraftMode = value end,
			width = "full",
			disabled = function() return not KHC.settings.EnableAuto end,
			default = KHC.defaults.CraftMode,
		},
		-- Emote mode
		{
			type = "description",
			title = "|c"..COLOR_KHRILLSELECT..KHC.langString.KHCSettings_title6.."|r",
			text = KHC.langString.KHCSettings_description6,
			width = "full",
		},
		{
			type = "checkbox",
			name = KHC.langString.KHCSettings_enable,
			tooltip = KHC.langString.KHCSettings_emotemode,
			getFunc = function() return KHC.settings.EmoteMode end,
			setFunc = function(value) KHC.settings.EmoteMode = value end,
			width = "full",
			disabled = function() return not KHC.settings.EnableAuto end,
			default = KHC.defaults.EmoteMode,
		},
		-- City mode
		{
			type = "description",
			title = "|c"..COLOR_KHRILLSELECT..KHC.langString.KHCSettings_title7.."|r",
			text = KHC.langString.KHCSettings_description7,
			width = "full",
		},
		{
			type = "checkbox",
			name = KHC.langString.KHCSettings_enable,
			tooltip = KHC.langString.KHCSettings_citymode,
			getFunc = function() return KHC.settings.CityMode end,
			setFunc = function(value) KHC:ToggleCityMode(value) end,
			width = "full",
			disabled = function() return not KHC.settings.EnableAuto end,
			default = KHC.defaults.CityMode,
		},
		-- Cyrodiil mode
		{
			type = "description",
			title = "|c"..COLOR_KHRILLSELECT..KHC.langString.KHCSettings_title8.."|r",
			text = KHC.langString.KHCSettings_description8,
			width = "full",
		},
		{
			type = "checkbox",
			name = KHC.langString.KHCSettings_enable,
			tooltip = KHC.langString.KHCSettings_cyrodiilmode,
			getFunc = function() return KHC.settings.CyrodiilMode end,
			setFunc = function(value) KHC:ToggleCyrodiilMode(value) end,
			width = "full",
			disabled = function() return not KHC.settings.EnableAuto end,
			default = KHC.defaults.CyrodiilMode,
		},
	}

	LAM2:RegisterOptionControls(ADDON_NAME, optionsTable)	
end

-- // **********
-- //  Debug
-- // **********
function KHC:msg(texte, extend)
	if KHC.isDebug then
		d(texte)
		if extend ~= false then
			d("default="..tostring(KHC.settings.DefaultHelm).."; manual="..tostring(KHC.manual))
			d("inCity="..tostring(KHC.inCity).."; Cyrodiil="..tostring(IsInCampaign()))
			d("weapons="..tostring(KHC.weapons).."; notDisarm="..tostring(KHC.notDisarm))
	--		d("helmbeforemount="..tostring(KHC.helmbeforemount))
			d("-------")
		end
	end
end

SLASH_COMMANDS["/khcdebug"] = function()
	KHC.isDebug = not KHC.isDebug
	KHC:msg("-- KHC Debug -- "..tostring(KHC.isDebug))
end
